{ Statements
 (C) 2005-2012, Andreas Berg. All Rights Reserved. }
unit _state;

interface

uses
 _common;

const
 stateNone         = 0;
 stateIF           = 1;
 stateFOR          = 2;
 stateWHILE        = 3;

procedure SetIF(cnd: boolean);
procedure SetWHILE(cnd: boolean);

function CheckStatements: boolean;
procedure CheckStateEnds;

implementation

uses
 _error, _scanner, _parser, _ident, _source, _main,
 _output, _reg, _header, _seg, _cpu, _model, _gen, _alias;

procedure SetIF(cnd: boolean);
var
 lv                : TDefValue;
begin
   Lv:= Source[CurLevel].StateLevel;
   if Source[CurLevel].Statements[Lv].Cond then begin
      Inc(Source[CurLevel].StateLevel);
      lv:= Source[CurLevel].StateLevel;
      SetLength(Source[CurLevel].Statements, lv + 1);
      Source[CurLevel].Statements[lv].Cond:= cnd;
      Source[CurLevel].Statements[lv].StateType:= stateIF;
      Source[CurLevel].Statements[lv].StartLine:= 0;
      Source[CurLevel].Statements[lv].Variable:= '';
      Source[CurLevel].Statements[lv].StartVal:= 0;
      Source[CurLevel].Statements[lv].EndVal:= 0;
      Source[CurLevel].Statements[lv].CurVal:= 0;
      Source[CurLevel].Statements[lv].Step:= 0;
   end else begin
      Inc(Source[CurLevel].StateSkip);
      Lv:= Source[CurLevel].StateSkip;
      SetLength(Source[CurLevel].StateSkipTable, Lv + 1);
      Source[CurLevel].StateSkipTable[Lv]:= stateIF;
      Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
   end;
end;

procedure SetWHILE(cnd: boolean);
var
 lv                : TDefValue;
begin
   Lv:= Source[CurLevel].StateLevel;
   if Source[CurLevel].Statements[Lv].Cond then begin
      Inc(Source[CurLevel].StateLevel);
      lv:= Source[CurLevel].StateLevel;
      SetLength(Source[CurLevel].Statements, lv + 1);
      Source[CurLevel].Statements[lv].Cond:= cnd;
      Source[CurLevel].Statements[lv].StateType:= stateWHILE;
      Source[CurLevel].Statements[lv].StartLine:= Source[CurLevel].CurLine;
      Source[CurLevel].Statements[lv].Variable:= '';
      Source[CurLevel].Statements[lv].StartVal:= 0;
      Source[CurLevel].Statements[lv].EndVal:= 0;
      Source[CurLevel].Statements[lv].CurVal:= 0;
      Source[CurLevel].Statements[lv].Step:= 0;
   end else begin
      Inc(Source[CurLevel].StateSkip);
      Lv:= Source[CurLevel].StateSkip;
      SetLength(Source[CurLevel].StateSkipTable, Lv + 1);
      Source[CurLevel].StateSkipTable[Lv]:= stateWHILE;
      Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
   end;
end;



function CheckStatements: boolean;
var
 sStatus           : boolean;
 iStat             : boolean;
 Lv, SLv           : TDefValue;
 Val1, Val2        : TAsmValue;
 eOpr              : byte;
 o, vName, toStr   : string;
 stn, nam, nam2    : string;
 c                 : char;
 t, id, i, sLine   : TDefValue;
 sVal, eVal, stVal : TAsmValue;
 cVal              : TAsmValue;
 sTyp              : byte;
 loopFound         : boolean;
 pOfs              : TDefValue;
 pCnt              : TAsmValue;
 pValOfs           : TDefValue;
 pValCnt           : TAsmValue;
 ss                : string;
 n                 : string;
 nFnd              : boolean;
begin
   sStatus:= false;
   if PriName <> '' then begin
      if PriName = '.IFPARSENAME' then begin
         sStatus:= true;
         ss:= GetName;
         if not IsErr then begin
            if ss <> '' then begin
               n:= ParseObj.Name;
               if n = ss then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFPARSENAME]!');
            end;
         end;
      end;

      if PriName = '.IFPARSENAMESTR' then begin
         sStatus:= true;
         ss:= GrabString;
         if not IsErr then begin
            n:= ParseObj.Name;
            if n = ss then
             SetIF(true)
            else
             SetIF(false);
         end;
      end;

      if PriName = '.IFPARSENAMES' then begin
         sStatus:= true;
         nFnd:= false;
         n:= ParseObj.Name;
         while true do begin
            if IsErr then break;
            ss:= GetName;
            if not IsErr then begin
               if ss <> '' then begin
                  if ss = n then nFnd:= true;
               end else begin
                  ErrorMsg('Name expected [.IFPARSENAMES]!');
               end;
               SkipBlank;
               if GetSrcChar = ',' then begin
                  NextChar;
               end else begin
                  break;
               end;
            end;
         end;
         if not IsErr then SetIF(nFnd);
      end;

      if PriName = '.IFNAMES' then begin
         sStatus:= true;
         nFnd:= false;
         n:= GetName;
         if (not IsErr) and (n <> '') then begin
            while true do begin
               if IsErr then break;
               ss:= GetName;
               if not IsErr then begin
                  if ss <> '' then begin
                     if ss = n then nFnd:= true;
                  end else begin
                     ErrorMsg('Name expected [.IFNAMES]!');
                  end;
                  SkipBlank;
                  if GetSrcChar = ',' then begin
                     NextChar;
                  end else begin
                     break;
                  end;
               end;
            end;
         end else begin
            if (n = '') and (not IsErr) then
             ErrorMsg('Name expected [.IFNAMES]!');
         end;
         if not IsErr then SetIF(nFnd);
      end;

      if PriName = '.IFDEF' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= GetIdentIndex(nam);
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFDEF]!');
            end;
         end;
      end;
      if PriName = '.IFNDEF' then begin
	       sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= GetIdentIndex(nam);
               if id = NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFNDEF]!');
            end;
         end;
      end;
      if PriName = '.IFB' then begin
         sStatus:= true;
         if Source[CurLevel].SrcType = srcMACRO then begin
            nam:= GetName;
            if not IsErr then begin
               if nam <> '' then begin
                  id:= GetIdentIndex(Source[CurLevel].FileName);
                  pOfs:= IdentList[id].ParamOffset;
                  pCnt:= IdentList[id].ParamCnt;
                  pValOfs:= Source[CurLevel].ParamValOfs;
                  pValCnt:= Source[CurLevel].ParamValCnt;
                  ss:= GetMacroParam(nam, pOfs, pCnt, pValOfs, pValCnt);
                  if ss = '' then
                   SetIF(true)
                  else
                   SetIF(false);
               end else begin
                  ErrorMsg('Name expected [.IFB]!');
               end;
            end;
         end else begin
            ErrorMsg('[.IFB] must be used inside a Macro/Object!');
         end;
      end;
      if PriName = '.IFNB' then begin
         sStatus:= true;
         if Source[CurLevel].SrcType = srcMACRO then begin
            nam:= GetName;
            if not IsErr then begin
               if nam <> '' then begin
                  id:= GetIdentIndex(Source[CurLevel].FileName);
                  pOfs:= IdentList[id].ParamOffset;
                  pCnt:= IdentList[id].ParamCnt;
                  pValOfs:= Source[CurLevel].ParamValOfs;
                  pValCnt:= Source[CurLevel].ParamValCnt;
                  ss:= GetMacroParam(nam, pOfs, pCnt, pValOfs, pValCnt);
                  if ss <> '' then
                   SetIF(true)
                  else
                   SetIF(false);
               end else begin
                  ErrorMsg('Name expected [.IFNB]!');
               end;
            end;
         end else begin
            ErrorMsg('[.IFNB] must be used inside a Macro/Object!');
         end;
      end;
      if (PriName = '.IFIDN') or (PriName = '.IFIDNI') then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               SkipBlank;
               if GetSrcChar = ',' then begin
                  NextChar;
                  nam2:= GetName;
                  if not IsErr then begin
                     if nam2 <> '' then begin
                        if nam = nam2 then
                         SetIF(true)
                        else
                         SetIF(false);
                     end else begin
                        SetIF(false);
                        Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
                     end;
                  end;
               end else begin
                  ErrorMsg('[ , ] expected [' + PriName + ']!');
               end;
            end else begin
               SetIF(false);
               Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
            end;
         end;
      end;
      if (PriName = '.IFDIF') or (PriName = '.IFDIFI') then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               SkipBlank;
               if GetSrcChar = ',' then begin
                  NextChar;
                  nam2:= GetName;
                  if not IsErr then begin
                     if nam2 <> '' then begin
                        if nam <> nam2 then
                         SetIF(true)
                        else
                         SetIF(false);
                     end else begin
                        SetIF(true);
                        Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
                     end;
                  end;
               end else begin
                  ErrorMsg('[ , ] expected [' + PriName + ']!');
               end;
            end else begin
               SetIF(true);
               Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
            end;
         end;
      end;
      if PriName = '.IFTRUE' then begin
         sStatus:= true;
         val1:= GetNumber(tAUTO);
         if not IsErr then begin
            if val1 <> 0 then
             SetIF(true)
            else
             SetIF(false);
         end;
      end;
      if PriName = '.IFFALSE' then begin
         sStatus:= true;
         val1:= GetNumber(tAUTO);
         if not IsErr then begin
            if val1 = 0 then
             SetIF(true)
            else
             SetIF(false);
         end;
      end;

      if PriName = '.IFNAME' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then
             SetIF(true)
            else
             SetIF(false);
            Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
         end;
      end;
      if PriName = '.IFVALUE' then begin
         sStatus:= true;
         SkipBlank;
         if IsDigit(GetSrcChar) then
          SetIF(true)
         else
          SetIF(false);
         Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
      end;
      if PriName = '.IFSTRING' then begin
         sStatus:= true;
         SkipBlank;
         if (GetSrcChar = '"') or (GetSrcChar = #39) then
          SetIF(true)
         else
          SetIF(false);
         Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
      end;

      if PriName = '.IFBYTE' then begin
         sStatus:= true;
         val1:= GetNumber(tAUTO);
         if (val1 < -128) or (val1 > 255) then
          SetIF(false)
         else
          SetIF(true);
      end;
      if PriName = '.IFWORD' then begin
         sStatus:= true;
         val1:= GetNumber(tAUTO);
         if (val1 < -32768) or (val1 > 65535) then
          SetIF(false)
         else
          SetIF(true);
      end;
      if PriName = '.IFDWORD' then begin
         sStatus:= true;
         val1:= GetNumber(tAUTO);
         if (val1 < -2147483648) or (val1 > 4294967295) then
          SetIF(false)
         else
          SetIF(true);
      end;
      if PriName = '.IFFARPTR' then begin
         sStatus:= true;
         val1:= GetNumber(tAUTO);
         if (val1 < -140737488355328) or (val1 > 281474976710655) then
          SetIF(false)
         else
          SetIF(true);
      end;

      if PriName = '.IFEQU' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               iStat:= false;
               id:= GetIdentIndex(nam);
               if id <> NotFound then begin
                  if IdentList[id].IdentType = itEQU then begin
                     iStat:= true;
                  end;
               end;
               SetIF(iStat);
            end else begin
               ErrorMsg('Name expected [.IFEQU]!');
            end;
         end;
      end;
      if PriName = '.IFEQUVALUE' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               iStat:= false;
               id:= GetIdentIndex(nam);
               if id <> NotFound then begin
                  if IdentList[id].IdentType = itEQU then begin
                     if IdentList[id].EquMode = equModeINT then begin
                        iStat:= true;
                     end;
                  end;
               end;
               SetIF(iStat);
            end else begin
               ErrorMsg('Name expected [.IFEQUVALUE]!');
            end;
         end;
      end;
      if PriName = '.IFEQUSTR' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               iStat:= false;
               id:= GetIdentIndex(nam);
               if id <> NotFound then begin
                  if IdentList[id].IdentType = itEQU then begin
                     if IdentList[id].EquMode = equModeSTR then begin
                        iStat:= true;
                     end;
                  end;
               end;
               SetIF(iStat);
            end else begin
               ErrorMsg('Name expected [.IFEQUSTR]!');
            end;
         end;
      end;
      if PriName = '.IFNAMEEQUSTR' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               ss:= GrabString;
               if not IsErr then begin
                  if nam = ss then
                   SetIF(true)
                  else
                   SetIF(false);
               end;
            end else begin
               ErrorMsg('Name expected [.IFNAMEEQUSTR]!');
            end;
         end;
      end;
      if PriName = '.IFOUTPUT' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= NotFound;
               if OutputCount > 0 then begin
                  i:= 0;
                  while i < OutputCount do begin
                     if OutputList[i].IdentName = nam then begin
                        id:= i;
                        break;
                     end;
                     Inc(i);
                  end;
               end;
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFOUTPUT]!');
            end;
         end;
      end;
      if PriName = '.IFREG' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= GetRegIndex(nam);
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFREG]!');
            end;
         end;
      end;
      if PriName = '.IFREGTABLE' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= GetRegTableIndex(nam);
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFREGTABLE]!');
            end;
         end;
      end;
      {if PriName = '.IFINREGTABLE' then begin}
         { If register is in a register table }
         {sStatus:= true; }
      {end;}
      if PriName = '.IFSEGMENT' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= NotFound;
               if SegCount > 0 then begin
                  i:= 0;
                  while i < SegCount do begin
                     if Segment[i].IdentName = nam then begin
                        id:= i;
                        break;
                     end;
                     Inc(i);
                  end;
               end;
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFSEGMENT]!');
            end;
         end;
      end;
      if PriName = '.IFHEADER' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= NotFound;
               if HeaderCount > 0 then begin
                  i:= 0;
                  while i < HeaderCount do begin
                     if HeaderList[i].IdentName = nam then begin
                        id:= i;
                        break;
                     end;
                     Inc(i);
                  end;
               end;
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFHEADER]!');
            end;
         end;
      end;
      if PriName = '.IFMODEL' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= NotFound;
               if ModelCount > 0 then begin
                  i:= 0;
                  while i < ModelCount do begin
                     if ModelList[i].Name = nam then begin
                        id:= i;
                        break;
                     end;
                     Inc(i);
                  end;
               end;
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFMODEL]!');
            end;
         end;
      end;
      if PriName = '.IFPROCESSOR' then begin
         sStatus:= true;
         nam:= GetName;
         if not IsErr then begin
            if nam <> '' then begin
               id:= NotFound;
               if ProcessorCount > 0 then begin
                  i:= 0;
                  while i < ProcessorCount do begin
                     if ProcessorList[i].Name = nam then begin
                        id:= i;
                        break;
                     end;
                     Inc(i);
                  end;
               end;
               if id <> NotFound then
                SetIF(true)
               else
                SetIF(false);
            end else begin
               ErrorMsg('Name expected [.IFPROCESSOR]!');
            end;
         end;
      end;

      if PriName = '.IF' then begin
         sStatus:= true;
            Val1:= GetNumber(tAUTO);
            if not IsErr then begin
               eOpr:= oprNONE;
               o:= GetName;
               if o <> '' then begin
                  if o = 'EQ' then eOpr:= oprEQ;
                  if o = 'NE' then eOpr:= oprNE;
                  if o = 'LT' then eOpr:= oprLT;
                  if o = 'GT' then eOpr:= oprGT;
                  if o = 'LE' then eOpr:= oprLE;
                  if o = 'GE' then eOpr:= oprGE;
                  if eOpr = oprNONE then
                   ErrorMsg('Invalid operator [' + o + ']!');
               end else begin
                  c:= GetSrcChar;
                  if c = '=' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprEQ;
                     end else begin
                        ErrorMsg('Another [ = ] expected!');
                     end;
                  end;
                  if c = '!' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprNE;
                     end else begin
                        ErrorMsg('[ = ] expected!');
                     end;
                  end;
                  if c = '<' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprLE;
                     end else begin
                        eOpr:= oprLT;
                     end;
                  end;
                  if c = '>' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprGE;
                     end else begin
                        eOpr:= oprGT;
                     end;
                  end;
	            	  if (c <> '=') and (c <> '!') and
                   (c <> '<') and (c <> '>') then begin
                     ErrorMsg('Invalid operator [ ' + GetSrcChar + ' ]!');
                  end;
               end;
               if not IsErr then begin
                  Val2:= GetNumber(tAUTO);
                  if not IsErr then begin
                     if eOpr = oprEQ then begin
                        if Val1 = Val2 then begin
                           SetIF(true);
                        end else begin
                           SetIF(false);
                        end;
                     end;
                     if eOpr = oprNE then begin
                        if Val1 <> Val2 then begin
                           SetIF(true);
                        end else begin
                           SetIF(false);
                        end;
                     end;
                     if eOpr = oprLT then begin
                        if Val1 < Val2 then begin
                           SetIF(true);
                        end else begin
                           SetIF(false);
                        end;
                     end;
                     if eOpr = oprGT then begin
                        if Val1 > Val2 then begin
                           SetIF(true);
                        end else begin
                           SetIF(false);
                        end;
                     end;
                     if eOpr = oprLE then begin
                        if Val1 <= Val2 then begin
                           SetIF(true);
                        end else begin
                           SetIF(false);
                        end;
                     end;
                     if eOpr = oprGE then begin
                        if Val1 >= Val2 then begin
                           SetIF(true);
                        end else begin
                           SetIF(false);
                        end;
                     end;
                  end;
               end;
            end;
      end;
      if PriName = '.IFS' then begin
         sStatus:= true;
         nam:= GrabString;
         if not IsErr then begin
            nam2:= GrabString;
            if not IsErr then begin
               if nam = nam2 then
                SetIF(true)
               else
                SetIF(false);
            end;
         end;
      end;
      if PriName = '.ELSE' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].StateSkip = 0 then begin
            if Source[CurLevel].Statements[Lv].StateType = stateIF then begin
               if Source[CurLevel].Statements[Lv].Cond then begin
                  Source[CurLevel].Statements[Lv].Cond:= false;
               end else begin
                  Source[CurLevel].Statements[Lv].Cond:= true;
               end;
               if Source[CurLevel].BreakFound then
                Source[CurLevel].Statements[Lv].Cond:= false;
            end else begin
               ErrorMsg('.ELSE without .IF!');
            end;
         end else begin
            SLv:= Source[CurLevel].StateSkip;
            if Source[CurLevel].StateSkipTable[SLv] <> stateIF then begin
               ErrorMsg('.ELSE without .IF!');
            end;
         end;
      end;
      if PriName = '.ENDIF' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].StateSkip = 0 then begin
            if Source[CurLevel].Statements[Lv].StateType = stateIF then begin
               Dec(Source[CurLevel].StateLevel);
               Source[CurLevel].Statements[Lv-1].Cond:= true;
               if Source[CurLevel].BreakFound then
                Source[CurLevel].Statements[Lv-1].Cond:= false;
            end else begin
               t:= Source[CurLevel].Statements[Lv].StateType;
	       if t = stateFOR then begin
                  ErrorMsg('[.NEXT] expected, but [.ENDIF] found!');
               end;
	       if t = stateWHILE then begin
                  ErrorMsg('[.WEND] expected, but [.ENDIF] found!');
               end;
               if (t <> stateFOR) and (t <> stateWHILE) then begin
                  ErrorMsg('.ENDIF without .IF!');
               end;
            end;
         end else begin
            SLv:= Source[CurLevel].StateSkip;
            if Source[CurLevel].StateSkipTable[SLv] <> stateIF then begin
               t:= Source[CurLevel].StateSkipTable[SLv];
               if t = stateFOR then begin
                  ErrorMsg('[.NEXT] expected, but [.ENDIF] found!');
               end;
	       if t = stateWHILE then begin
                  ErrorMsg('[.WEND] expected, but [.ENDIF] found!');
               end;
               if (t <> stateFOR) and (t <> stateWHILE) then begin
                  ErrorMsg('.ENDIF without .IF!');
               end;
            end else begin
               Dec(Source[CurLevel].StateSkip);
            end;
         end;
      end;

      if PriName = '.FOR' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].Statements[Lv].Cond then begin
            vName:= GetName;
            if vName <> '' then begin
               SkipBlank;
               if GetSrcChar = '=' then begin
                  NextChar;
                  sVal:= GetNumber(tAUTO);
                  if not IsErr then begin
                     toStr:= GetName;
                     if toStr = 'TO' then begin
                        eVal:= GetNumber(tAUTO);
                        if not IsErr then begin
                           stVal:= 1;
                           stn:= GetName;
                           if stn <> '' then begin
                              if stn = 'STEP' then begin
                                 stVal:= GetNumber(tAUTO);
                              end else begin
                                 ErrorMsg('[STEP] expected, but [' + stn + '] found!');
                              end;
                           end;
                           if not IsErr then begin
                              id:= GetIdentIndex(vName);
                              if id = NotFound then begin
                                 AddEquInt(vName, sVal);
                              end else begin
                                 if IdentList[id].IdentType = itEQU then begin
                                    if IdentList[id].EquMode = equModeINT then begin
                                       IdentList[id].IValue:= sVal;
                                    end else begin
                                       ErrorMsg('Identifier is not a valid Equate [' + vName + ']!');
                                    end;
                                 end else begin
                                    ErrorMsg('Identifier is not an Equate [' + vName + ']!');
                                 end;
                              end;
                              if not IsErr then begin
                                 Inc(Source[CurLevel].StateLevel);
                                 Lv:= Source[CurLevel].StateLevel;
                                 SetLength(Source[CurLevel].Statements, Lv + 1);
                                 Source[CurLevel].Statements[Lv].StateType:= stateFOR;
                                 Source[CurLevel].Statements[Lv].StartLine:= Source[CurLevel].CurLine+1;
                                 Source[CurLevel].Statements[Lv].Variable:= vName;
                                 Source[CurLevel].Statements[Lv].StartVal:= sVal;
                                 Source[CurLevel].Statements[Lv].CurVal:= sVal;
                                 Source[CurLevel].Statements[Lv].EndVal:= eVal;
                                 Source[CurLevel].Statements[Lv].Step:= stVal;
                                 if stVal = 0 then begin
                                    Source[CurLevel].Statements[Lv].Cond:= false;
                                 end else begin
                                    if stVal > 0 then begin
                                       if sVal > eVal then begin
                                          Source[CurLevel].Statements[Lv].Cond:= false;
                                       end else begin
                                          Source[CurLevel].Statements[Lv].Cond:= true;
                                       end;
                                    end else begin
                                       if sVal < eVal then begin
                                          Source[CurLevel].Statements[Lv].Cond:= false;
                                       end else begin
                                          Source[CurLevel].Statements[Lv].Cond:= true;
                                       end;
                                    end;
                                 end;
                              end;
                           end;
                        end;
                     end else begin
                        if toStr = '' then begin
                           ErrorMsg('[TO] expected!');
                        end else begin
                           ErrorMsg('[TO] expected, but [' + toStr + '] found!');
                        end;
                     end;
                  end;
               end else begin
                  ErrorMsg('[ = ] expected!');
               end;
            end else begin
               ErrorMsg('Equate expected!');
            end;
         end else begin
            Inc(Source[CurLevel].StateSkip);
            Lv:= Source[CurLevel].StateSkip;
            SetLength(Source[CurLevel].StateSkipTable, Lv + 1);
            Source[CurLevel].StateSkipTable[Lv]:= stateFOR;
            Source[CurLevel].Pos:= Source[CurLevel].Len + 1;
         end;
      end;
      if PriName = '.NEXT' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].StateSkip = 0 then begin
            if Source[CurLevel].Statements[Lv].StateType = stateFOR then begin
               if Source[CurLevel].Statements[Lv].Cond then begin
                  cVal:= Source[CurLevel].Statements[Lv].CurVal;
                  eVal:= Source[CurLevel].Statements[Lv].EndVal;
                  sVal:= Source[CurLevel].Statements[Lv].Step;
                  sLine:= Source[CurLevel].Statements[Lv].StartLine;
                  nam:= Source[CurLevel].Statements[Lv].Variable;
                  id:= GetIdentIndex(nam);
                  cVal:= cVal + sVal;
                  IdentList[id].IValue:= cVal;
                  if sVal > 0 then begin
                     if cVal > eVal then begin
                        Dec(Source[CurLevel].StateLevel);
                        Source[CurLevel].Statements[Lv-1].Cond:= true;
                        if Source[CurLevel].BreakFound then
                         Source[CurLevel].BreakFound:= false;
                     end else begin
                        if not Source[CurLevel].BreakFound then begin
                           Source[CurLevel].Statements[Lv].CurVal:= cVal;
                           Source[CurLevel].CurLine:= sLine-1;
                        end else begin
                           Source[CurLevel].BreakFound:= false;
                           Dec(Source[CurLevel].StateLevel);
                           Source[CurLevel].Statements[Lv-1].Cond:= true;
                        end;
                     end;
                  end else begin
                     if cVal < eVal then begin
                        Dec(Source[CurLevel].StateLevel);
                        Source[CurLevel].Statements[Lv-1].Cond:= true;
                        if Source[CurLevel].BreakFound then
                         Source[CurLevel].BreakFound:= false;
                     end else begin
                        if not Source[CurLevel].BreakFound then begin
                           Source[CurLevel].Statements[Lv].CurVal:= cVal;
                           Source[CurLevel].CurLine:= sLine-1;
                        end else begin
                           Source[CurLevel].BreakFound:= false;
                           Dec(Source[CurLevel].StateLevel);
                           Source[CurLevel].Statements[Lv-1].Cond:= true;
                        end;
                     end;
                  end;
               end else begin
                  Dec(Source[CurLevel].StateLevel);
                  Source[CurLevel].Statements[Lv-1].Cond:= true;
                  if Source[CurLevel].BreakFound then
                   Source[CurLevel].BreakFound:= false;
               end;
               if Source[CurLevel].BreakFound then
                Source[CurLevel].BreakFound:= false;
            end else begin
               t:= Source[CurLevel].Statements[Lv].StateType;
               if t = stateIF then begin
                  ErrorMsg('[.ENDIF] expected, but [.NEXT] found!');
               end;
	       if t = stateWHILE then begin
                  ErrorMsg('[.WEND] expected, but [.NEXT] found!');
               end;
               if (t <> stateIF) and (t <> stateWHILE) then begin
                  ErrorMsg('.NEXT without .FOR!');
               end;
            end;
         end else begin
            SLv:= Source[CurLevel].StateSkip;
            if Source[CurLevel].StateSkipTable[SLv] <> stateFOR then begin
               t:= Source[CurLevel].StateSkipTable[SLv];
               if t = stateIF then begin
                  ErrorMsg('[.ENDIF] expected, but [.NEXT] found!');
               end;
	       if t = stateWHILE then begin
                  ErrorMsg('[.WEND] expected, but [.NEXT] found!');
               end;
               if (t <> stateIF) and (t <> stateWHILE) then begin
                  ErrorMsg('.NEXT without .FOR!');
               end;
            end else begin
               Dec(Source[CurLevel].StateSkip);
            end;
         end;
      end;

      if PriName = '.WHILE' then begin
         sStatus:= true;

            Val1:= GetNumber(tAUTO);
            if not IsErr then begin
               eOpr:= oprNONE;
               o:= GetName;
               if o <> '' then begin
                  if o = 'EQ' then eOpr:= oprEQ;
                  if o = 'NE' then eOpr:= oprNE;
                  if o = 'LT' then eOpr:= oprLT;
                  if o = 'GT' then eOpr:= oprGT;
                  if o = 'LE' then eOpr:= oprLE;
                  if o = 'GE' then eOpr:= oprGE;
                  if eOpr = oprNONE then
                   ErrorMsg('Invalid operator [' + o + ']!');
               end else begin
                  c:= GetSrcChar;
                  if c = '=' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprEQ;
                     end else begin
                        ErrorMsg('Another [ = ] expected!');
                     end;
                  end;
                  if c = '!' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprNE;
                     end else begin
                        ErrorMsg('[ = ] expected!');
                     end;
                  end;
                  if c = '<' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprLE;
                     end else begin
                        eOpr:= oprLT;
                     end;
                  end;
                  if c = '>' then begin
                     NextChar;
                     if GetSrcChar = '=' then begin
                        NextChar;
                        eOpr:= oprGE;
                     end else begin
                        eOpr:= oprGT;
                     end;
                  end;
		              if (c <> '=') and (c <> '!') and
                   (c <> '<') and (c <> '>') then begin
                     ErrorMsg('Invalid operator [ ' + GetSrcChar + ' ]!');
                  end;
               end;
               if not IsErr then begin
		              Val2:= GetNumber(tAUTO);
                  if not IsErr then begin
                     if eOpr = oprEQ then begin
                        if Val1 = Val2 then begin
                           SetWHILE(true);
                        end else begin
                           SetWHILE(false);
                        end;
                     end;
                     if eOpr = oprNE then begin
                        if Val1 <> Val2 then begin
                           SetWHILE(true);
                        end else begin
                           SetWHILE(false);
                        end;
                     end;
                     if eOpr = oprLT then begin
                        if Val1 < Val2 then begin
                           SetWHILE(true);
                        end else begin
                           SetWHILE(false);
                        end;
                     end;
                     if eOpr = oprGT then begin
                        if Val1 > Val2 then begin
                           SetWHILE(true);
                        end else begin
                           SetWHILE(false);
                        end;
                     end;
                     if eOpr = oprLE then begin
                        if Val1 <= Val2 then begin
                           SetWHILE(true);
                        end else begin
                           SetWHILE(false);
                        end;
                     end;
                     if eOpr = oprGE then begin
                        if Val1 >= Val2 then begin
                           SetWHILE(true);
                        end else begin
                           SetWHILE(false);
                        end;
                     end;
                  end;
               end;
            end;
      end;
      if PriName = '.WEND' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].StateSkip = 0 then begin
            if Source[CurLevel].Statements[Lv].StateType = stateWHILE then begin
               if Source[CurLevel].Statements[Lv].Cond then begin
                  sLine:= Source[CurLevel].Statements[Lv].StartLine;
                  Source[CurLevel].CurLine:= sLine-1;
               end;
               Dec(Source[CurLevel].StateLevel);
               Source[CurLevel].Statements[Lv-1].Cond:= true;
               if Source[CurLevel].BreakFound then
                Source[CurLevel].BreakFound:= false;
            end else begin
               t:= Source[CurLevel].Statements[Lv].StateType;
               if t = stateIF then begin
                  ErrorMsg('[.ENDIF] expected, but [.WEND] found!');
               end;
	       if t = stateFOR then begin
                  ErrorMsg('[.NEXT] expected, but [.WEND] found!');
               end;
               if (t = stateIF) and (t = stateFOR) then begin
                  ErrorMsg('.WEND without .WHILE!');
               end;
            end;
         end else begin
            SLv:= Source[CurLevel].StateSkip;
            if Source[CurLevel].StateSkipTable[SLv] <> stateWHILE then begin
               t:= Source[CurLevel].StateSkipTable[SLv];
               if t = stateIF then begin
                  ErrorMsg('[.ENDIF] expected, but [.WEND] found!');
               end;
	       if t = stateFOR then begin
                  ErrorMsg('[.NEXT] expected, but [.WEND] found!');
               end;
               if (t = stateIF) and (t = stateFOR) then begin
                  ErrorMsg('.WEND without .WHILE!');
               end;
            end else begin
               Dec(Source[CurLevel].StateSkip);
            end;
         end;
      end;

      if PriName = '.BREAK' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].Statements[Lv].Cond then begin
            loopFound:= false;
            i:= Lv;
            while i >= 1 do begin
               sTyp:= Source[CurLevel].Statements[i].StateType;
               if (sTyp = stateFOR) or (sTyp = stateWHILE) then begin
                  loopFound:= true;
                  break;
               end;
               Dec(i);
            end;
            if not loopFound then begin
               ErrorMsg('.BREAK without loop!');
            end else begin
               Source[CurLevel].BreakFound:= true;
               Source[CurLevel].Statements[Lv].Cond:= false;
            end;
         end;
      end;
      if PriName = '.CONTINUE' then begin
         sStatus:= true;
         Lv:= Source[CurLevel].StateLevel;
         if Source[CurLevel].Statements[Lv].Cond then begin
            loopFound:= false;
            i:= Lv;
            while i >= 1 do begin
               sTyp:= Source[CurLevel].Statements[i].StateType;
               if sTyp = stateFOR then begin
                  loopFound:= true;
                  Source[CurLevel].StateLevel:= i;
                  cVal:= Source[CurLevel].Statements[i].CurVal;
                  eVal:= Source[CurLevel].Statements[i].EndVal;
                  sVal:= Source[CurLevel].Statements[i].Step;
                  sLine:= Source[CurLevel].Statements[i].StartLine;
                  nam:= Source[CurLevel].Statements[i].Variable;
                  id:= GetIdentIndex(nam);
                  cVal:= cVal + sVal;
                  IdentList[id].IValue:= cVal;
                  if sVal > 0 then begin
                     if cVal <= eVal then begin
                        Source[CurLevel].Statements[i].CurVal:= cVal;
                        Source[CurLevel].CurLine:= sLine-1;
                     end else begin
                        Source[CurLevel].Statements[i].Cond:= false;
                     end;
                  end else begin
                     if cVal >= eVal then begin
                        Source[CurLevel].Statements[i].CurVal:= cVal;
                        Source[CurLevel].CurLine:= sLine-1;
                     end else begin
                        Source[CurLevel].Statements[i].Cond:= false;
                     end;
                  end;
                  break;
               end;
               if sTyp = stateWHILE then begin
                  loopFound:= true;
                  Source[CurLevel].StateLevel:= i;
                  sLine:= Source[CurLevel].Statements[i].StartLine;
                  Source[CurLevel].CurLine:= sLine-1;
                  Dec(Source[CurLevel].StateLevel);
                  Source[CurLevel].Statements[i-1].Cond:= true;
                  break;
               end;
               Inc(i);
            end;
            if not loopFound then begin
               ErrorMsg('.CONTINUE without loop!');
            end;
         end;
      end;
   end;
   if IsErr then sStatus:= false;
   CheckStatements:= sStatus;
end;

procedure CheckStateEnds;
var
 SkipLv, Lv, i     : TDefValue;
 t                 : byte;
begin
   SkipLv:= Source[CurLevel].StateSkip;
   i:= SkipLv;
   while i >= 1 do begin
      t:= Source[CurLevel].StateSkipTable[i];
      if t = stateIF then FatalError('[.IF] without [.ENDIF] [' +
       Source[CurLevel].FileName + ']!');
      if t = stateFOR then FatalError('[.FOR] without [.NEXT] [' +
       Source[CurLevel].FileName + ']!');
      if t = stateWHILE then FatalError('[.WHILE] without [.WEND] [' +
       Source[CurLevel].FileName + ']!');
      Dec(i);
   end;
   Lv:= Source[CurLevel].StateLevel;
   i:= Lv;
   while i >= 1 do begin
      t:= Source[CurLevel].Statements[i].StateType;
      if t = stateIF then FatalError('[.IF] without [.ENDIF] [' +
       Source[CurLevel].FileName + ']!');
      if t = stateFOR then FatalError('[.FOR] without [.NEXT] [' +
       Source[CurLevel].FileName + ']!');
      if t = stateWHILE then FatalError('[.WHILE] without [.WEND] ['
       + Source[CurLevel].FileName + ']!');
      Dec(i);
   end;
end;

end.
 
