{ Bin2Hex 0.01
 (C) 2001-2012, Andreas Berg. All Rights Reserved. }
program bin2hex;

uses
 Crt, SysUtils, _common, _conv, _diskio, _pbar;

const
 bin2hexStr         = 'Bin2Hex 0.01';
 blankChar          = '.';

var
 iFile              : string;
 oFile              : string;
 owrit              : boolean;
 dmpScr             : boolean;
 ch                 : char;
 ifi                : file of byte;
 ofi                : text;
 ldata              : array[1..16] of word;
 ofs                : int64;
 i                  : integer;

 err, f             : boolean;
 oldPerc, perc      : integer;

 curByte            : int64;
 fLen               : int64;
 b                  : byte;
 cnt                : byte;
 s                  : string;


function InStr(c: char; s: string): boolean;
var
 i, ln              : integer;
 iStr               : boolean;
begin
   iStr:= false;
   ln:= length(s);
   if ln > 0 then begin
      for i:= 1 to ln do begin
         if c = s[i] then begin
            iStr:= true;
            break;
         end;
      end;
   end;
   InStr:= iStr;
end;

function IsPrintChar(c: char): boolean;
begin
   IsPrintChar:= ((UpCase(c) in ['A'..'Z']) or (c in ['0'..'9'])
    or InStr(c, ',<>|[]\/(){}+-*_?"!#¤$€=^~'));
end;

procedure ClearLineData;
var
 i                  : integer;
begin
   for i:= 1 to 16 do ldata[i]:= 256;
end;

function OffsetToStr: string;
begin
   OffsetToStr:= DwordToHex(ofs);
end;

function LdataToStr: string;
var
 ss                 : string;
 i                  : word;
begin
   ss:= OffsetToStr + '  ';
   for i:= 1 to 16 do begin
      if LData[i] = 256 then
       ss:= ss + '   '
      else
       ss:= ss + ByteToHex(LData[i]) + ' ';
   end;
   ss:= ss + ' ';
   for i:= 1 to 16 do begin
      if LData[i] = 256 then begin
         ss:= ss + ' ';
      end else begin
         if IsPrintChar(chr(LData[i])) then
          ss:= ss + chr(LData[i])
         else
          ss:= ss + blankChar;
      end;
   end;
   LdataToStr:= ss;
end;


begin
   writeln(bin2hexStr + ' / (C) 2001-2012, Andreas Berg. All Rights Reserved.');
   if paramcount < 1 then begin
      writeln('usage:  bin2hex  input-file  [options]  [output-file]');
      WriteLn('');
      WriteLn('OPTION              DESCRIPTION');
      Writeln(' -d                 Dump to screen');
      Writeln('');
   end else begin
      writeln;

      err:= false;
      iFile:= '';
      oFile:= '';
      dmpScr:= false;

      for i:= 1 to ParamCount do begin
         s:= ParamStr(i);
         if s[1] = '-' then begin
            f:= false;
            if UpperCase(s) = '-D' then begin
               dmpScr:= true;
               f:= true;
            end;

            if not f then begin
               Writeln('ERROR: Invalid option [' + s + ']!');
               err:= true;
            end;
         end else begin
            if iFile = '' then
             iFile:= ParamStr(i)
            else begin
               if oFile = '' then
                oFile:= ParamStr(i)
               else begin
                  Writeln('ERROR: Input and Output files already set!');
                  err:= true;
               end;
            end;
         end;
      end;

      if (iFile = '') and (not err) then begin
         Writeln('ERROR: No input file!');
         err:= true;
      end else begin
         if oFile = '' then oFile:= RemoveExt(iFile) + '.hex';
      end;

      if not err then begin

         if UpperCase(iFile) = UpperCase(oFile) then begin
            writeln('ERROR: Filenames is matching!');
         end else begin

            if FileExists(iFile) then begin
               owrit:= true;
               if FileExists(oFile) then begin
                  owrit:= false;
                  write('Output-file already exists! Overwrite? [Y/n]: ');
                  repeat
                  until KeyPressed;
                  ch:= ReadKey;
                  if UpCase(ch) = 'Y' then owrit:= true;
                  write(ch);
                  writeln;
                  writeln;
               end;

               if owrit then begin

                  ofs:= 0;
                  curByte:= 1;
                  cnt:= 1;
                  oldPerc:= 0;
                  perc:= 0;

                  ClearLineData;

                  assign(iFi, iFile);
                  reset(iFi);

                     fLen:= FileSize(iFi);

                     if not dmpScr then begin
                        Write('Converting: ');
                        BarX:= WhereX;
                        BarY:= WhereY;
                        DrawProgressBar(BarX, BarY, BarSize, ofs, fLen);
                     end;

                     assign(oFi, oFile);
                     rewrite(oFi);

                        writeln(oFi, '[' + iFile + '] CONVERTED WITH ' + bin2hexStr);
                        writeln(oFi, '');

                        s:= 'OFFSET    0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F   BINARY';
                        if dmpScr then writeln(s);
                        writeln(oFi, s);

                        while true do begin
                           if curByte > fLen then break;
                           read(iFi, b);

                           LData[cnt]:= b;
                           cnt:= cnt + 1;

                           if cnt > 16 then begin
                              s:= LDataToStr;
                              if dmpScr then writeln(s);
                              writeln(oFi, s);
                              ClearLineData;
                              cnt:= 1;
                              ofs:= ofs + 16;

                              if not dmpScr then begin
                                 perc:= ((ofs * 100) div fLen);
                                 if (perc > 100) then perc:= 100;
                                 if perc > oldPerc then begin
                                    DrawProgressBar(BarX, BarY, BarSize, ofs, fLen);
                                    oldPerc:= perc;
                                 end;
                              end;
                           end;

                           Inc(curByte);
                        end;

                        if cnt > 1 then begin
                           s:= LDataToStr;
                           if dmpScr then writeln(s);
                           writeln(oFi, s);
                        end;
                     close(oFi);
                  close(iFi);

                  if not dmpScr then begin
                     DrawProgressBar(BarX, BarY, BarSize, fLen, fLen);
                     writeln;
                  end;

                  writeln;
                  writeln('*** DONE ***');
                  writeln;

               end;
            end else begin
               writeln('ERROR: File not found [' + iFile + ']!');
            end;
         end;

      end;

   end;
end.
